<template>
    <div class="the-style-selector">
        <select class="the-edit-bar-input" :disabled="style == ''" v-model="style" aria-label="text style">
            <option value="" disabled>----</option>
            <option v-for="k in Object.entries(enabled_styles)" :key="k[0]" :value="k[0]">{{k[1]}}</option>
        </select>
    </div>
</template>

<script lang="ts" setup>
import {computed} from 'vue'
import type { TheEditor } from '../TheEditor';

const props = defineProps<{
    editor: TheEditor,
}>()

const enabled_styles = computed(()=>{
    if (!props.editor) return []
    let styles: Record<string,string>= {}
    let extension_names = new Set(props.editor.extensionManager.extensions.map(ex => ex.name))
    let heading_levels = props.editor.extensionManager.extensions.find(ex => ex.name == 'heading')?.options.levels
    if (extension_names.has('paragraph')) styles['paragraph'] = 'Paragraph'
    if (extension_names.has('codeBlock')) styles['code'] = 'Code Block'
    if (heading_levels){
        heading_levels.forEach((level:number) => {
            styles[`h${level}`] = `Heading ${level}`
        })
    }
    return styles
})

const style = computed({
    get: () => {
        if (!props.editor) return "";
        return props.editor.isActive("paragraph") ? "paragraph"
        : props.editor.isActive("codeBlock") ? "code"
        : props.editor.isActive("heading", { level: 1 }) ? "h1"
        : props.editor.isActive("heading", { level: 2 }) ? "h2"
        : props.editor.isActive("heading", { level: 3 }) ? "h3"
        : props.editor.isActive("heading", { level: 4 }) ? "h4"
        : props.editor.isActive("heading", { level: 4 }) ? "h5"
        : props.editor.isActive("heading", { level: 4 }) ? "h6"
        : "";
    },
    set: (v: string) => {
            let command = props.editor.chain().focus();
            switch (v) {
                case "paragraph":
                    command = command?.setParagraph();
                    break;
                case "code":
                    command = command?.setCodeBlock();
                    break;
                case "h1":
                    command = command?.setHeading({ level: 1 });
                    break;
                case "h2":
                    command = command?.setHeading({ level: 2 });
                    break;
                case "h3":
                    command = command?.setHeading({ level: 3 });
                    break;
                case "h4":
                    command = command?.setHeading({ level: 4 });
                    break;
                default:
                    return;
            }
            command?.run();
        },

    })
</script>
